<script type="text/javascript">
	const icons = {
		read: 'read.svg',
		append: 'append.svg',
		subscribe: 'subscribe.svg',
	}
	RED.nodes.registerType('eventstore', {
		category: 'storage',
		color: 'LightSeaGreen',
		paletteLabel: 'eventstore',
		defaults: {
			name: { value: "" },
			mode: { value: 'append' },
			access: { value: "", type: "eventstore-config" },
			streamId: { value: "" },
			eventType: { value: "" },
			batchSize: { value: 1 },
		},
		inputs: 1,
		outputs: 1,
		inputLabels: "event or event data: { type: string, data: any } or any",
		outputLabels: "result: any",
		icon: function() { return icons[this.mode] || 'logo.svg' },
		label: function() { return this.name || 'eventstore' },
	});
</script>

<script type="text/html" data-template-name="eventstore">
	<div class="form-row">
		<label><b>EventStore DB Node</b></label>
	</div>
	<div class="form-row">
		<label for="node-input-name"><b>Name</b></label>
		<input type="text" id="node-input-name">
	</div>
	<div class="form-row">
		<label for="node-input-mode"><b>Mode</b></label>
		<select id="node-input-mode">
			<option value="read">Read all events</option>
			<option value="append">Append new events</option>
			<option value="subscribe">Subscribe to new events</option>
		</select>
	</div>
	<div class="form-row">
		<label for="node-input-access"><b>Access</b></label>
		<input type="text" id="node-input-access">
	</div>
	<div class="form-row">
		<label for="node-input-streamId"><b>Stream ID</b></label>
		<input type="text" id="node-input-streamId">
	</div>
	<div class="form-row">
		<label for="node-input-eventType"><b>Event Type</b></label>
		<input type="text" id="node-input-eventType">
	</div>
	<div class="form-row">
		<label for="node-input-batchSize"><b>Batch Size</b></label>
		<!-- https://developers.eventstore.com/clients/dotnet/21.2/appending.html#append-events-to-a-stream -->
		<input type="number" min="1" max="4095" id="node-input-batchSize">
	</div>
</script>

<script type="text/html" data-help-name="eventstore">
	<p>Access an EventStore DB</p>
	<!-- TODO: document -->
	<h3><b>Input:</b></h3>
	<dl class="message-properties">
			<dt>payload <span class="property-type">string</span></dt>
			<dd>connectionString address</dd>
	</dl>
	<h3><b>Output:</b></h3>
	<dl class="message-properties">
			<dt>payload <span class="property-type">Date</span></dt>
			<dd>Transmittion time</dd>
</dl>
	<h3><b>Details:</b></h3>
	<p>
		Node-RED wrapper around the <a 
		href="https://github.com/EventStore/EventStore-Client-NodeJS"
		>EventStoreDB NodeJS Client</a>.
	</p>
</script>
